#ifndef __ELC_H_
#define __ELC_H_
#include <stdint.h>
#include "common.h"
#define _00_ELC_EVENT_INTP0           (0x00U) /* ELSELR00 */
#define _01_ELC_EVENT_INTP1           (0x01U) /* ELSELR01 */
#define _02_ELC_EVENT_INTP2           (0x02U) /* ELSELR02 */
#define _03_ELC_EVENT_INTP3           (0x03U) /* ELSELR03 */
#define _04_ELC_EVENT_INTP4           (0x04U) /* ELSELR04 */
#define _05_ELC_EVENT_INTP5           (0x05U) /* ELSELR05 */
#define _06_ELC_EVENT_INTKEY          (0x06U) /* ELSELR06 */
#define _07_ELC_EVENT_INTRTC          (0x07U) /* ELSELR07 */
#define _08_ELC_EVENT_INTTMA          (0x08U) /* ELSELR04 */
#define _09_ELC_EVENT_INTTM00         (0x09U) /* ELSELR05 */
#define _0A_ELC_EVENT_INTTM01         (0x0AU) /* ELSELR06 */
#define _0B_ELC_EVENT_INTTM02         (0x0BU) /* ELSELR07 */
#define _0C_ELC_EVENT_INTTM03         (0x0CU) /* ELSELR08 */
#define _0D_ELC_EVENT_INTCMP0         (0x0DU) /* ELSELR09 */
#define _0E_ELC_EVENT_INTCMP1         (0x0EU) /* ELSELR0A */
#define _0F_ELC_EVENT_INTOSTC         (0x0FU) /* ELSELR0B */


/*
    Event output destination select register n (ELSELRn) 
*/
/* Event output destination select register n (ELSELn1 - ELSELn0) */
#define _00_ELC_EVENT_LINK_OFF            (0x00U) /* event link disabled */
#define _01_ELC_EVENT_LINK_AD             (0x01U) /* select operation of peripheral function 1 to A/D converter */
#define _02_ELC_EVENT_LINK_TI00           (0x02U) /* select operation of peripheral function 2 to Timer input of timer 8 channel 0 */
#define _03_ELC_EVENT_LINK_TI01           (0x03U) /* select operation of peripheral function 3 to Timer input of timer 8 channel 1 */
#define _04_ELC_EVENT_LINK_TMA            (0x04U) /* select operation of peripheral function 4 to Timer input of timer A channel 1 */
#define _05_ELC_EVENT_LINK_DAC            (0x05U) /* select operation of peripheral function 5 to DAC */

/***********************************************************************************************************************
Macro definitions
***********************************************************************************************************************/
#define ELC_DESTINATION_COUNT              (0x0FU)

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
void ELC_Start(uint32_t event_src, uint32_t event_dst);
void ELC_Stop(uint32_t event);
#endif
