/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/*****************************************************************************/
/** \file opa.h
**
** History:
** 
*****************************************************************************/
#ifndef __LVD_H_
#define __LVD_H_

#ifdef __cplusplus
extern "C"
{
#endif

/*****************************************************************************/
/* Include files */
/*****************************************************************************/
#include "CMS32H6157.h"
#include "cgc.h"
/*****************************************************************************/
/* Global pre-processor symbols/macros ('#define') */
/*****************************************************************************/

/*****************************************************************************/
/* Global type definitions ('typedef') */
/*****************************************************************************/
#define LVD_OutMask_Flag			0x02
#define LVD_Lvif_Flag					0x01

typedef enum
{
	LVD_Mode_Int  = 0,
	LVD_Mode_Reset  = 1,
}	LVD_Mode_t;

typedef enum
{
	LVD_Detect_High  = 0,     //VLVDH
	LVD_Detect_Low  = 1,			//VLVDLVLVD
}	LVD_Detect_t;


typedef struct
{
	LVD_Mode_t LVD_Mode;				/*!< This member configures the LVD work mode. */

	LVD_Detect_t LVD_Detect;			/*!< Specifies the detect level of LVD
											This parameter can be a value of @ref LVD_Detect_High */

} LVD_InitTypeDef;

/*****************************************************************************/
/* Global variable declarations ('extern', definition in C source) */
/*****************************************************************************/


/*****************************************************************************/
/* Global function prototypes ('extern', definition in C source) */
/*****************************************************************************/
void LVD_Init(LVD_InitTypeDef* LVD_InitStruct);

#ifdef __cplusplus
}
#endif

#endif /* __LVD_H_ */

