/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/*****************************************************************************/
/** \file sigmaDeltaAdc.h
**
** 
**
** History:
** 
*****************************************************************************/
#ifndef __SIGMADELTAADC_H__
#define __SIGMADELTAADC_H__
/*****************************************************************************/
/* Include files */
/*****************************************************************************/
#include "userdefine.h"
#include "common.h"
#include "gpio.h"
/*****************************************************************************/
/* Global pre-processor symbols/macros ('#define') */
/*****************************************************************************/
#ifndef TRUE
  /** Value is true (boolean_t type) */
  #define TRUE        (1)
#endif

#ifndef FALSE
  /** Value is false (boolean_t type) */
  #define FALSE       (0)
#endif 

/*----------------------------------------------------------------------------
 **Sigma Delta Adc˿
---------------------------------------------------------------------------*/

//PC13  SCK
//PC14	SDA


#define ADC_SDA_OUTPUT_MODE 		GPIO_Output_Enable(&PORT->PC,GPIO_Pin_14)
#define ADC_SDA_INPUT_MODE  		GPIO_Input_Enable(&PORT->PC,GPIO_Pin_14)


#define SIGMA_DELTA_ADC_SCK_L 		GPIO_ResetBits(GPIO_PORTC,GPIO_Pin_13)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
#define SIGMA_DELTA_ADC_SCK_H 		GPIO_SetBits(GPIO_PORTC,GPIO_Pin_13)
#define W_SIGMA_DELTA_ADC_SDA_L 	GPIO_ResetBits(GPIO_PORTC,GPIO_Pin_14)
#define W_SIGMA_DELTA_ADC_SDA_H 	GPIO_SetBits(GPIO_PORTC,GPIO_Pin_14)
#define R_SIGMA_DELTA_ADC_SDA_L	 	(0 == GPIO_ReadInputDataBit(GPIO_PORTC,GPIO_Pin_14))
#define R_SIGMA_DELTA_ADC_SDA_H 	(0 != GPIO_ReadInputDataBit(GPIO_PORTC,GPIO_Pin_14))




/*----------------------------------------------------------------------------
 **Sigma Delta Adc
---------------------------------------------------------------------------*/
#define CFG1_CMD_READ 0x56
#define CFG2_CMD_READ 0x5A
#define CFG3_CMD_READ 0x5E
#define CFG4_CMD_READ 0x52

#define CFG1_CMD_WRITE 0x65  
#define CFG2_CMD_WRITE 0x69
#define CFG3_CMD_WRITE 0x6D
#define CFG4_CMD_WRITE 0x61

#define REG1_DEFAULT_CFG 0x36
#define REG2_DEFAULT_CFG 0x10
#define REG3_DEFAULT_CFG 0x88
#define REG4_DEFAULT_CFG 0x81

/*----------------------------------------------------------------------------
 **Sigma Delta Adcתѡ
---------------------------------------------------------------------------*/
typedef enum
{
	ODR_1280HZ_ADCFRE_328KHZ = 0,
	ODR_640HZ_ADCFRE_328KHZ = 1,
	ODR_320HZ_ADCFRE_328KHZ = 2,
	ODR_80HZ_ADCFRE_328KHZ = 3,
	ODR_20HZ_ADCFRE_328KHZ = 4,
	ODR_10HZ_ADCFRE_328KHZ = 5,
	ODR_5HZ_ADCFRE_328KHZ = 6,
	ODR_2P5HZ_ADCFRE_328KHZ = 7,
}ODR_E;

/*----------------------------------------------------------------------------
 **Sigma Delta AdcƵ
---------------------------------------------------------------------------*/
typedef enum
{
	ADCFRE_328KHZ,
	ADCFRE_656KHZ,
}ADC_FRE_E;

/*----------------------------------------------------------------------------
 **Sigma Delta Adc PGAŴѡ
---------------------------------------------------------------------------*/
typedef enum
{
	PGA_2 = 0,
	PGA_4 = 1,
	PGA_8 = 2,
	PGA_16 = 3,
	PGA_32 = 4,
	PGA_64 = 5,
	PGA_128 = 6,
	PGA_256 = 7,
}PGA_E;


/*----------------------------------------------------------------------------
 **Sigma Delta Adc LDOοѹѡ
---------------------------------------------------------------------------*/
typedef enum
{
	SET_LDO_3V = 0,
	SET_LDO_2P4V = 1,
	SET_LDO_2P6V = 2,
	SET_LDO_3P3V = 3,
	SET_LDO_VDD = 4,
}LDO_E;

/*----------------------------------------------------------------------------
 **Sigma Delta Adc ͨ
---------------------------------------------------------------------------*/
typedef enum
{
	CH_TYPE_CHx = 0x00,				//Ĭ
	CH_TYPE_CHOP = 0x01,			//
	CH_TYPE_TP = 0x02,				//¶
	CH_TYPE_INSHORT = 0x03,			//źڶ
	CH_TYPE_NO_PGA = 0x04,			//bypass pga,ֱͨADC
	CH_TYPE_BG = 0x06,				//ڲBG
	CH_TYPE_INSHORT_NO_PGA = 0x07,	//źڶֱͨADC
	
}CHAN_TYPE_E;

/*----------------------------------------------------------------------------
 **Sigma Delta Adc ͨѡ
---------------------------------------------------------------------------*/
typedef enum
{
	CH_SEL_CH1 = 0,					//ͨ1
	CH_SEL_CH2 = 1,					//ͨ2
	
}CHAN_SEL_E;

/*----------------------------------------------------------------------------
 **Sigma Delta Adc 
---------------------------------------------------------------------------*/
typedef enum
{
	POWER_SEL_LOW,					//͹
	POWER_SEL_HIGH,					//߹
	
}CHAN_NUM_E;

/*----------------------------------------------------------------------------
 **Sigma Delta Adc жϴ
---------------------------------------------------------------------------*/
typedef enum
{
	PHASE_WRITE_CFG,
	PHASE_READ_CFG,
	PHASE_READ_DAT,
}PHASE_E;

/*----------------------------------------------------------------------------
 **Sigma Delta Adc ṹ
---------------------------------------------------------------------------*/
typedef struct
{
	uint8_t odrSel;
	uint8_t pgaSel;
	
	uint8_t chanSel:1;
	uint8_t sampleOk:1;
	uint8_t isCfg1Update:1;
	uint8_t isCfg2Update:1;
	uint8_t isCfg3Update:1;
	uint8_t isCfg4Update:1;
	uint8_t reserved:2;

	uint8_t readCfgCnt;
	
	uint16_t adcConvertCnt;

	PHASE_E phase;
	
	int32_t adcVal;
	
}SIGMA_DELTA_ADC_INFO_S;

/*----------------------------------------------------------------------------
 **SDADCCON1Ĵλ
---------------------------------------------------------------------------*/
typedef struct
{
	uint8_t pgaSel:3;
	uint8_t chSel:1;
	uint8_t osr:2;
	uint8_t setLdo:2;  
}REG_CON1_S;

/*----------------------------------------------------------------------------
 **SDADCCON2Ĵλ
---------------------------------------------------------------------------*/
typedef struct
{
	uint8_t fChopAdc:1;
	uint8_t enChopb:1;
	uint8_t osr:1;
	uint8_t fadc:1;
	uint8_t lpwr:1;
	uint8_t chSel:3;
}REG_CON2_S;

/*----------------------------------------------------------------------------
 **SDADCCON3Ĵλ
---------------------------------------------------------------------------*/
typedef struct
{
	uint8_t reserved:1;
	uint8_t ocpDisLdo:1;
	uint8_t bypassLdo:1;
	uint8_t deadZone:1;
	uint8_t trimOs:4;
}REG_CON3_S;

/*----------------------------------------------------------------------------
 **SDADCCON4Ĵλ
---------------------------------------------------------------------------*/
typedef struct
{
	uint8_t fChopPga:2;
	uint8_t reserved1:1;
	uint8_t reserved2:1;
	uint8_t trimBg:4;
}REG_CON4_S;

/*----------------------------------------------------------------------------
 **SDADCCON1Ĵ
---------------------------------------------------------------------------*/
typedef union
{
	uint8_t byteCfg;
	REG_CON1_S bitCfg;
}REG_CON1_U;

/*----------------------------------------------------------------------------
 **SDADCCON2Ĵ
---------------------------------------------------------------------------*/
typedef union
{
	uint8_t byteCfg;
	REG_CON2_S bitCfg;
}REG_CON2_U;

/*----------------------------------------------------------------------------
 **SDADCCON3Ĵ
---------------------------------------------------------------------------*/
typedef union
{
	uint8_t byteCfg;
	REG_CON3_S bitCfg;
}REG_CON3_U;

/*----------------------------------------------------------------------------
 **SDADCCON4Ĵ
---------------------------------------------------------------------------*/
typedef union
{
	uint8_t byteCfg;
	REG_CON4_S bitCfg;
}REG_CON4_U;





/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_OneClock
						 һSCLK
 ** \param [in] none       
 ** \return  none
*****************************************************************************/
void SigmaDeltaAdc_OneClock(void);

/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_WriteOneBit
 **			  		дһbit
 ** \param [in] 
 **					 sda_dat: 01
 ** \return  none
*****************************************************************************/
void SigmaDeltaAdc_WriteOneBit(uint8_t sda_dat);

/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_ReadOneBit
 **			  	 һbit
 ** \param [in] none
 ** \return  10
*****************************************************************************/
uint8_t SigmaDeltaAdc_ReadOneBit(void);

/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_WriteReg
 **			 		 дSigma Delta Adc
 ** \param [in] wr_cmd: 
								CFG1_CMD_WRITE  
								CFG2_CMD_WRITE
								CFG3_CMD_WRITE
								CFG4_CMD_WRITE 0x61
 **							datֵ
 ** \return  none
 ** \note 	 
*****************************************************************************/
void SigmaDeltaAdc_WriteReg(uint8_t wr_cmd,uint8_t dat);

/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_ReadReg
 **			 		 Sigma Delta Adc
 ** \param [in] wr_cmd: 
								CFG1_CMD_READ  
								CFG2_CMD_READ
								CFG3_CMD_READ
								CFG4_CMD_READ
 ** \return  ֵ
 ** \note 	 
*****************************************************************************/
uint8_t SigmaDeltaAdc_ReadReg(uint8_t rd_cmd);


extern SIGMA_DELTA_ADC_INFO_S sigmaDeltaAdcInfo;
extern REG_CON1_U regCfg1Info;
extern REG_CON2_U regCfg2Info;
extern REG_CON3_U regCfg3Info;
extern REG_CON4_U regCfg4Info;



#endif
