/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file opa.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "lvd.h"
/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/
//ֻڸλ&жģʽʱ޸LVISֵ
#define LVD_Mode_INTReset			1
/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/


/*****************************************************************************
 ** \brief	 LVD_LVIS_Unlock
 **			 ʹLVISĴĲ
 ** \param [in] none
 ** \return  none
 ** \note  ֻڸλ&жģʽʱ޸LVISֵsystem_cms32h6157.cģʽ
 *****************************************************************************/
void LVD_Lvis_Unlock(void)
{
	LVD->LVIM |= LVD_LVIM_LVISEN_Msk;		
}

/*****************************************************************************
 ** \brief	 LVD_LVIS_Lock
 **			 ֹLVISĴĲ
 ** \param [in] none
 ** \return  none
 ** \note   ֻڸλ&жģʽʱ޸LVISֵsystem_cms32h6157.cģʽ
 *****************************************************************************/
void LVD_Lvis_Lock(void)
{
	LVD->LVIM &= ~LVD_LVIM_LVISEN_Msk;		
}


/*****************************************************************************
 ** \brief	 LVD_Status_Flag
 **			 LVD״̬־
 ** \param [in] LFlag
 **               LVD_OutMask_Flag: α־
 **               LVD_Lvif_Flag: ѹ־
 ** \return  Ӧı־״̬
 ** \note    
 *****************************************************************************/
uint8_t LVD_Status_Flag(uint8_t LFlag)
{	
	if((LVD->LVIM & LFlag) == LFlag)
		return LFlag;
	else
		return 0;
}

/*****************************************************************************
 ** \brief	 LVD_LvdMode_Config
 **			 LVDĹģʽ
 ** \param [in] LMode
 **               LVD_Mode_Int:жģʽ
 **               LVD_Mode_Reset:λģʽ
 ** \return  none
 ** \note    
 *****************************************************************************/
void LVD_LvdMode_Config(uint8_t LMode)
{
	LVD_Lvis_Unlock();
	if(LMode == LVD_Mode_Int)
		LVD->LVIS &= ~LVD_LVIS_LVIMD_Msk;	
	else
		LVD->LVIS |= LVD_LVIS_LVIMD_Msk;	
  LVD_Lvis_Lock();	
}

/*****************************************************************************
 ** \brief	 LVD_LvdDetect_Config
 **			 ѡLVDƽ
 ** \param [in] LMode
 **               LVD_Detect_High:ߵƽ
 **               LVD_Detect_Low:͵ƽ
 ** \return  none
 ** \note    
 *****************************************************************************/
void LVD_LvdDetect_Config(uint8_t LDetect)
{
	if(LVD_Mode_INTReset)
	{
		LVD_Lvis_Unlock();
		if(LDetect == LVD_Detect_High)
			LVD->LVIS &= ~LVD_LVIS_LVILV_Msk;	
		else
			LVD->LVIS |= LVD_LVIS_LVILV_Msk;		
		LVD_Lvis_Lock();
	}
}


/*****************************************************************************
 ** \brief	 LVD_Init
 **			 LVDƽģʽ
 ** \param [in] LMode
 **               LVD_Detect_High:ߵƽ
 **               LVD_Detect_Low:͵ƽ
 ** \return  none
 ** \note    
 *****************************************************************************/
void LVD_Init(LVD_InitTypeDef* LVD_InitStruct)
{
	if(LVD_Mode_INTReset)
	{
		LVD_Lvis_Unlock();
		LVD->LVIS = LVD_InitStruct->LVD_Detect | (LVD_InitStruct->LVD_Mode << LVD_LVIS_LVIMD_Pos);
		LVD_Lvis_Lock();
	}
	
}






