/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H6157
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/10/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "dma_demo.h"
#include "adc_demo.h"
#include "interval_demo.h"

#define ADC_ENABLE   1

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t   g_AdcIntTaken;

uint16_t get_value[8*2];
uint16_t get_value1[256];



int main()
{
    uint32_t msCnt;     // count value of 1ms

    int i = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);

#if ADC_ENABLE
    /*the adc hardwareTriggerNoWait test(use interval timer trigger ADC convertor)*/
    printf("Hello, UART\n");
    Interval_Init(IT_FIL, 10000);
    IT_Start();

    Adc_Hardwait_Init();
    //  ADC_Set_HardTrigger(ADC_ExternalTrig_Hardware_Wait, ADC_HardwareTrig_INTIT);
    ADC_Start(ADC_Channel_2);


    for (i = 0; i < 10; i++)
    {
        while (INTC_GetPendingIRQ(ADC_IRQn) == 0);
        printf("ADC Get Value = 0x%04X\n", ADC->ADCR);
		INTC_ClearPendingIRQ(ADC_IRQn);     //clear INTAD interrupt flag		
    }

    IT_Stop();
    ADC_Stop();
#endif
}




