/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H6157
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "rtc_demo.h"
#include "cgc.h"
#include "gpio.h"
#include "pcbz.h"
#include "tim_demo.h"
//#define  USED_FMX_AS_FCLK
//#define  USED_FSUB_AS_FCLK
//#define  USED_FIH_AS_FCLK
//#define  USED_FIL_AS_FCLK
#define  SET_MAINOSC_AND_SUBOSC
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};

		GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_1, GROUP_AF_PCLBUZ0);		// CLKBUZ0  
    GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_2, GROUP_AF_PCLBUZ1); // CLKBUZ1

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);
	
	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_3;	
	PCBZ_Init(&PCBZ_InitStructure);	
	
    /*CLKBUZ1 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);
	
	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_1;  //ѡclkbuz ͨ1
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FSUB;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FSUB_0;	
	PCBZ_Init(&PCBZ_InitStructure);	

}

int main()
{
    uint32_t msCnt;     // count value of 1ms

    //-----------------------------------------------------------------------
    // clock setting
    //-----------------------------------------------------------------------
/*ʹⲿϵͳʱΪcpuʱԼΧ·ʱ,עҪӾ*/	
#ifdef USED_FMX_AS_FCLK 
	CGC_HSEConfig(OSC_OSCILLATOR,OSC_UNDER_10M);
	CGC_HSE_CFG_AS_FCLK();  //ⲿϵͳʱΪcpuʱԼΧ·ʱ

    PCBZIO_Init();	
	Uart0_Init(19200);
	printf("Select FMX as system clock\n");
#endif	
/*ⲿϵͳʱcpuʱԼΧ·ʱ*/	
#ifdef USED_FSUB_AS_FCLK 
	CGC_LSEConfig(OSC_OSCILLATOR,OSC_NORMAL_POWER);
	CGC_LSE_CFG_AS_FCLK();   
	Tim8_SquareOutput();
	PCBZIO_Init();	
#endif	
/*ڲϵͳʱΪcpuʱԼΧ·ʱ*/	
#ifdef USED_FIH_AS_FCLK 
    SystemCoreClockUpdate();   
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt); 
	Tim8_SquareOutput();
    Uart0_Init(19200);
	printf("Select FIH as system clock\n");
#endif
/*ڲϵͳʱΪcpuʱԼΧ·ʱ*/
#ifdef USED_FIL_AS_FCLK 
	CGC_LSI_CFG_AS_FCLK();
	Tim8_SquareOutput();
#endif

/*ⲿϵͳʱΪcpuʱԼΧ·ʱӣͬʱⲿϵͳʱΪʱ*/
#ifdef SET_MAINOSC_AND_SUBOSC 
	CGC_Osc_Setting(OSC_OSCILLATOR,OSC_UNDER_10M,OSC_OSCILLATOR,OSC_NORMAL_POWER);
	CGC_HSE_CFG_AS_FCLK();  //ⲿϵͳʱΪcpuʱԼΧ·ʱ
	Uart0_Init(19200);
	printf("Select FMX as system clock\n");
	
	PCBZIO_Init();	   

#endif

}



