/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A6703
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "dac_demo.h"
#include "cmp_demo.h"
#include "delay_demo.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
	uint32_t msCnt; 	// count value of 1ms
	uint8_t set_value[8];
	int i=0,j=0;	
	
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	delay_init(SystemCoreClock);
	
	Uart0_Init(19200);

	Cmp0_Init();
	Dac_Init();	
	printf("Please apply voltage on the PA00/VCIN0 pin.\n");

	for(i=1; i<8; i++)
	{
		set_value[i] = i * 256 / sizeof(set_value);	
	}
	
	for(i=1; i<sizeof(set_value); i++)
	{
		g_Cmp0IntTaken = 0;		

		delayMS(1);
		for(j=0; j<256; j++) 
		{
			DAC_OutSet(j);
			delayMS(1);
			if(g_Cmp0IntTaken) 
			{
				printf("pSide Set Value = 0x%02X, ", DAC->DACS0);
				printf("C0MON = %d, ", (CMP->COMPMDR & CMP_COMPMDR_C0MON_Msk) >> 3);
				printf("IntTaken = %d\n", g_Cmp0IntTaken);	
				break;
			}
		}		
	}	
	while(1)
	{
		;
	}
}



