/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H6157
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "iica_demo.h"
#include "delay_demo.h"
#define SLVADDR                                 (0xA0U)   /* the IIC Slave Address of DAC on motherboard */
extern volatile uint8_t   g_iica_tx_end;             /* iica0 send data end */
extern volatile uint8_t   g_iica_rx_end;             /* iica0 receive data end */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

extern uint16_t  g_iica_rx_len;                     /* iica1 receive data length */

uint8_t buf[256];
uint8_t txbuf[3] = {0xAA, 0x55, 0x5A};
int main()
{
    uint8_t Register = 0;
    uint32_t msCnt;     // count value of 1ms
    uint16_t length = 0;

    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock); //ʱʼ

    Uart0_Init(115200);

    Iica0_Init();

    printf("I2CA slave sample test.\n");

    for (;;)
    {
#ifdef I2CA_USING_POLLING
        memset(buf, 0, sizeof(buf));
        I2CA_Slave_ReceiveData(buf, sizeof(buf), &length);
        delayMS(20);
        //      printf("I2CA slave recv length = %d.\n", length);
        //      printf("Data =");
        //      for (int i = 0; i < length; i++)
        //      {
        //          printf(" 0x%02X", buf[i]);
        //      }
        //      printf(".\n");
#else
        IICA_SlaveReceive(SLVADDR, buf, sizeof(buf));

        while (g_iica_rx_end == 0);

        delayMS(20);
        //      printf("I2CA slave recv length = %d.\n", g_iica_rx_len);
        //      printf("Data =");
        //      for (int i = 0; i < g_iica_rx_len; i++)
        //      {
        //          printf(" 0x%02X", buf[i]);
        //      }
        //      printf(".\n");
#endif

#ifdef I2CA_USING_POLLING
//        I2CA_Slave_TransmitData(&Register, txbuf, sizeof(txbuf));
        //      printf("I2CA slave transmit register = 0x%02X.\r\n", Register);
        delayMS(20);
#else
        IICA_SlaveSend(SLVADDR, txbuf, sizeof(txbuf));

        while (g_iica_tx_end == 0);

        delayMS(20);
#endif
    }
}



