#include "interval_demo.h"

uint32_t   g_ItIntTaken;
/***********************************************************************************************************************
* Function Name: Interval_Init
* @brief  This function initializes the IntervalTimer module.
* @param  It_clk - select the operaton clock of IntervalTimer
		  @arg IT_FSUB   sub system clock   
		  @arg IT_FIL    internal low speed  oscillator
		  @arg IT_FHOCO  internal high speed  oscillator  
		  @arg IT_FMX    high system clock   
* @param  counter_val - the expected interval timer value
*         for IT_FSUB(32.768KHz)  timeValue =counter/32768
*         IT_ FIL(15KHz)       timeValue =counter*1/15000  
*		  for IT_FHOCO/IT_FMX  timeValue = counter* (1*FreqScaler/freq)
* @return None
***********************************************************************************************************************/
void Interval_Init(uint8_t It_clk, uint16_t counter)
{
    IT_InitTypeDef IT_InitStructure;

    IT_InitStructure.IT_ClkSource =  It_clk;
    IT_InitStructure.IT_Freqscaler = IT_FreqScaler_976;
    IT_InitStructure.IT_Counter = counter;
    IT_Init(&IT_InitStructure);

    ISR_Register(IT_IRQn, it_interrupt);     //RTCжϷ·ע
}

/***********************************************************************************************************************
* Function Name: adc_interrupt
* @brief  UART1 Receive interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void it_interrupt(void *msg)
{
    INTC_ClearPendingIRQ(IT_IRQn);     //clear INTAD interrupt flag
    g_ItIntTaken++;
	PORT->PC ^= (1<<1);
}
