/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_opa.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "opa_demo.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	OPA_Config
 **			8bit dac as the input of OPA 
 **     the output pin is OPA_DA, and the pin_n had been connected to DA
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void Opa_Init(void)
{		
		GPIO_InitTypeDef GPIO_InitStruct = {0};
		OPA_InitTypeDef OPA_InitStructure = {0};
	 
		GPIO_PinAFConfig(GPIO_PORTD, GPIO_Pin_5, GROUP_AF_ODEFAULT);	  //Set OPA_FB 
    GPIO_PinAFConfig(GPIO_PORTD, GPIO_Pin_4, GROUP_AF_ODEFAULT);  //Set OPA_out
	
		/*OPA_FB GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_ANA;
    GPIO_Init(GPIO_PORTD, &GPIO_InitStruct);	

    /*OPA_OUT GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
		GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;	
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_ANA;
    GPIO_Init(GPIO_PORTD, &GPIO_InitStruct);		
	
		/*OPA CONFIG*/
    OPA_InitStructure.OPA_Input = OPA_Input_8bitDAC;
		OPA_InitStructure.OPA_Current = OPA_Current_none;
		OPA_InitStructure.OPA_Mode = OPA_Mode_Buff;     
		OPA_Init(&OPA_InitStructure); 
		 
}

