/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/******************************************************************************/
/** \file base_types.h
 **
 ** 
 **
 ** History:
 **   
 **
 *****************************************************************************/
#ifndef   __BASE_TYPE_H__
#define   __BASE_TYPE_H__
/*****************************************************************************/
/* Include files                                                      
*****************************************************************************/

/*****************************************************************************/
/* Global pre-processor symbols/macros ('#define')                           */
/*****************************************************************************/
#define   __I     volatile const       /*!< Defines 'read only' permissions */
#define   __O     volatile             /*!< Defines 'write only' permissions */
#define   __IO    volatile             /*!< Defines 'read / write' permissions */


/******************************************************************************
 * Global type definitions
 ******************************************************************************/
 /* exact-width signed integer types */
typedef   signed            char int8_t;
typedef   signed short      int int16_t;
typedef   signed            long  int32_t;

 /* exact-width unsigned integer types */
typedef unsigned            char uint8_t;
typedef unsigned short      int uint16_t;
typedef unsigned           long  uint32_t;


 /*****************************************************************************/
/* Global variable declarations ('extern', definition in C source)           */
/*****************************************************************************/


#ifndef TRUE
  /** Value is true (boolean_t type) */
  #define TRUE        (1)
#endif

#ifndef FALSE
  /** Value is false (boolean_t type) */
  #define FALSE       (0)
#endif  

/** Returns the minimum value out of two values */
#define MIN( X, Y )  ((X) < (Y) ? (X) : (Y))

/** Returns the maximum value out of two values */
#define MAX( X, Y )  ((X) > (Y) ? (X) : (Y))

/** Returns the dimension of an array */
#define DIM( X )  (sizeof(X) / sizeof(X[0]))



/*****************************************************************************/
/* Global function prototypes ('extern', definition in C source)             */
/*****************************************************************************/

#endif  /*_BASE_TYPE_H*/







 