#ifndef __SIGMADELTAADC_DEMO_H__
#define __SIGMADELTAADC_DEMO_H__

#include "sigmadeltaadc.h"
#include "isr.h"
#include "intp.h"
#include <stdio.h>
/*****************************************************************************/
/* Global pre-processor symbols/macros ('#define') */
/*****************************************************************************/
//#define USE_FORMULA

/*****************************************************************************/
/* Global type definitions ('typedef') */
/*****************************************************************************/



/*****************************************************************************/
/* Global variable declarations ('extern', definition in C source) */
/*****************************************************************************/


/*****************************************************************************/
/* Global function prototypes ('extern', definition in C source) */
/*****************************************************************************/
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_OutPutRate
 **			 		 Sigma Delta Adcת
 ** \param [in] speed: ODR_Eöֵ
								adc_fre  ADC_FRE_Eöֵ

 ** \return  none
 ** \note 	 
*****************************************************************************/
void SigmaDeltaAdc_OutPutRate(ODR_E speed,ADC_FRE_E adc_fre);
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_PgaSet
 **			 		 Sigma Delta Adc PGAŴ
 ** \param [in] pga: PGA_Eöֵ
 ** \return  none
 ** \note 	 
*****************************************************************************/
void SigmaDeltaAdc_PgaSet(PGA_E pga);
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_LdoSet
 **			 		 Sigma Delta Adc LDOѹ
 ** \param [in] ldo_vol: LDO_Eöֵ
 ** \return  none
 ** \note 	 
*****************************************************************************/
void  SigmaDeltaAdc_LdoSet(LDO_E ldo_vol);
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_ChanSel
 **			 		 Sigma Delta Adc LDOͨͨ
 ** \param [in] chan_sel: CHAN_SEL_Eöֵ
 **							chan_typeCHAN_TYPE_Eöֵ
 ** \return  none
 ** \note 	 
*****************************************************************************/
void  SigmaDeltaAdc_ChanSel(CHAN_SEL_E chan_sel,CHAN_TYPE_E chan_type);
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_ReadyInit	
						 Sigma Delta AdcԤʼIOڡ˿жϺͼĴʼֵ
 ** \param [in] none       
 ** \return  none
*****************************************************************************/
void SigmaDeltaAdc_ReadyInit(void);
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_Init	
						 Sigma Delta AdcʼжЩĴҪд
 ** \param [in] none       
 ** \return  none
*****************************************************************************/
void  SigmaDeltaAdc_Init(void);
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_ReadVal	
						 ȡSigma Delta Adcֵ
 ** \param [in] adc_info SIGMA_DELTA_ADC_INFO_Sṹ      
 ** \return  Sigma Delta Adcֵ
*****************************************************************************/
int32_t SigmaDeltaAdc_ReadVal(SIGMA_DELTA_ADC_INFO_S *adc_info);
/*****************************************************************************
 ** \brief	 SigmaDeltaAdc_Handle	
						 Sigma Delta AdcֱдúͶȡadcֵ
 ** \param 	 none      
 ** \return  none
*****************************************************************************/
void SigmaDeltaAdc_Handle(void);

/******************************************************************************
* Function Name: Sigmadeltaadc_Init
* @brief  init Sigma_deltaadc demo
* @param  none
* @return none
*******************************************************************************/
void Sigmadeltaadc_Init(void);
#endif
